osg::RefMatrixf Class Reference

`#include <Matrixf>`

Inheritance diagram for osg::RefMatrixf:

## Public Member Functions

| RefMatrixf ()
| RefMatrixf (const Matrixf &other)
| RefMatrixf (const Matrixd &other)
| RefMatrixf (const RefMatrixf &other)
| RefMatrixf (Matrixf::value_type const *const def)

RefMatrixf (Matrixf::value_type a00, Matrixf::value_type a01, Matrixf::value_type a02, Matrixf::value_type a03, Matrixf::value_type a10, Matrixf::value_type a11, Matrixf::value_type a12, Matrixf::value_type a13, Matrixf::value_type a20, Matrixf::value_type a21, Matrixf::value_type a22, Matrixf::value_type a23, Matrixf::value_type a30, Matrixf::value_type a31, Matrixf::value_type a32, Matrixf::value_type a33)

virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::Matrixf
| Matrixf ()
| Matrixf (const Matrixf &mat)
| Matrixf (const Matrixd &mat)
| Matrixf (float const *const ptr)
| Matrixf (double const *const ptr)
| Matrixf (const Quat &quat)
| Matrixf (value_type a00, value_type a01, value_type a02, value_type a03, value_type a10, value_type a11, value_type a12, value_type a13, value_type a20, value_type a21, value_type a22, value_type a23, value_type a30, value_type a31, value_type a32, value_type a33)
| ~Matrixf ()
int | compare (const Matrixf &m) const
bool | operator< (const Matrixf &m) const
bool | operator== (const Matrixf &m) const
bool | operator!= (const Matrixf &m) const
value_type & | operator() (int row, int col)
value_type | operator() (int row, int col) const
bool | valid () const
bool | isNaN () const
Matrixf & | operator= (const Matrixf &rhs)
Matrixf & | operator= (const Matrixd &other)
void | set (const Matrixf &rhs)
void | set (const Matrixd &rhs)
void | set (float const *const ptr)
void | set (double const *const ptr)
void | set (value_type a00, value_type a01, value_type a02, value_type a03, value_type a10, value_type a11, value_type a12, value_type a13, value_type a20, value_type a21, value_type a22, value_type a23, value_type a30, value_type a31, value_type a32, value_type a33)
value_type * | ptr ()
const value_type * | ptr () const
bool | isIdentity () const
void | makeIdentity ()
void | makeScale (const Vec3f &)
void | makeScale (const Vec3d &)
void | makeScale (value_type, value_type, value_type)
void | makeTranslate (const Vec3f &)
void | makeTranslate (const Vec3d &)
void | makeTranslate (value_type, value_type, value_type)
void | makeRotate (const Vec3f &from, const Vec3f &to)
void | makeRotate (const Vec3d &from, const Vec3d &to)
void | makeRotate (value_type angle, const Vec3f &axis)
void | makeRotate (value_type angle, const Vec3d &axis)
void | makeRotate (value_type angle, value_type x, value_type y, value_type z)
void | makeRotate (const Quat &)
void | makeRotate (value_type angle1, const Vec3f &axis1, value_type angle2, const Vec3f &axis2, value_type angle3, const Vec3f &axis3)
void | makeRotate (value_type angle1, const Vec3d &axis1, value_type angle2, const Vec3d &axis2, value_type angle3, const Vec3d &axis3)
void | decompose (osg::Vec3f &translation, osg::Quat &rotation, osg::Vec3f &scale, osg::Quat &so) const
void | decompose (osg::Vec3d &translation, osg::Quat &rotation, osg::Vec3d &scale, osg::Quat &so) const
void | makeOrtho (double left, double right, double bottom, double top, double zNear, double zFar)
bool | getOrtho (double &left, double &right, double &bottom, double &top, double &zNear, double &zFar) const
bool | getOrtho (float &left, float &right, float &bottom, float &top, float &zNear, float &zFar) const
void | makeOrtho2D (double left, double right, double bottom, double top)
void | makeFrustum (double left, double right, double bottom, double top, double zNear, double zFar)
bool | getFrustum (double &left, double &right, double &bottom, double &top, double &zNear, double &zFar) const
bool | getFrustum (float &left, float &right, float &bottom, float &top, float &zNear, float &zFar) const
void | makePerspective (double fovy, double aspectRatio, double zNear, double zFar)
bool | getPerspective (double &fovy, double &aspectRatio, double &zNear, double &zFar) const
bool | getPerspective (float &fovy, float &aspectRatio, float &zNear, float &zFar) const
void | makeLookAt (const Vec3d &eye, const Vec3d &center, const Vec3d &up)
void | getLookAt (Vec3f &eye, Vec3f &center, Vec3f &up, value_type lookDistance=1.0f) const
void | getLookAt (Vec3d &eye, Vec3d &center, Vec3d &up, value_type lookDistance=1.0f) const
bool | invert (const Matrixf &rhs)
bool | invert_4x3 (const Matrixf &rhs)
bool | invert_4x4 (const Matrixf &rhs)
bool | transpose (const Matrixf &rhs)
bool | transpose3x3 (const Matrixf &rhs)
void | orthoNormalize (const Matrixf &rhs)
Vec3f | preMult (const Vec3f &v) const
Vec3d | preMult (const Vec3d &v) const
Vec3f | postMult (const Vec3f &v) const
Vec3d | postMult (const Vec3d &v) const
Vec3f | operator* (const Vec3f &v) const
Vec3d | operator* (const Vec3d &v) const
Vec4f | preMult (const Vec4f &v) const
Vec4d | preMult (const Vec4d &v) const
Vec4f | postMult (const Vec4f &v) const
Vec4d | postMult (const Vec4d &v) const
Vec4f | operator* (const Vec4f &v) const
Vec4d | operator* (const Vec4d &v) const
void | setRotate (const Quat &q)
Quat | getRotate () const
void | setTrans (value_type tx, value_type ty, value_type tz)
void | setTrans (const Vec3f &v)
void | setTrans (const Vec3d &v)
Vec3d | getTrans () const
Vec3d | getScale () const
void | mult (const Matrixf &, const Matrixf &)
void | preMult (const Matrixf &)
void | postMult (const Matrixf &)
void | preMultTranslate (const Vec3d &v)
void | preMultTranslate (const Vec3f &v)
void | postMultTranslate (const Vec3d &v)
void | postMultTranslate (const Vec3f &v)
void | preMultScale (const Vec3d &v)
void | preMultScale (const Vec3f &v)
void | postMultScale (const Vec3d &v)
void | postMultScale (const Vec3f &v)
void | preMultRotate (const Quat &q)
void | postMultRotate (const Quat &q)
void | operator*= (const Matrixf &other)
Matrixf | operator* (const Matrixf &m) const
Matrixf | operator* (value_type rhs) const
Matrixf & | operator*= (value_type rhs)
Matrixf | operator/ (value_type rhs) const
Matrixf & | operator/= (value_type rhs)
Matrixf | operator+ (const Matrixf &rhs) const
Matrixf & | operator+= (const Matrixf &rhs)

## Protected Member Functions

virtual | ~RefMatrixf ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Public Types inherited from osg::Matrixf
typedef float | value_type
typedef double | other_value_type
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Static Public Member Functions inherited from osg::Matrixf
static Matrixf | identity (void)
static Matrixf | scale (const Vec3f &sv)
static Matrixf | scale (const Vec3d &sv)
static Matrixf | scale (value_type sx, value_type sy, value_type sz)
static Matrixf | translate (const Vec3f &dv)
static Matrixf | translate (const Vec3d &dv)
static Matrixf | translate (value_type x, value_type y, value_type z)
static Matrixf | rotate (const Vec3f &from, const Vec3f &to)
static Matrixf | rotate (const Vec3d &from, const Vec3d &to)
static Matrixf | rotate (value_type angle, value_type x, value_type y, value_type z)
static Matrixf | rotate (value_type angle, const Vec3f &axis)
static Matrixf | rotate (value_type angle, const Vec3d &axis)
static Matrixf | rotate (value_type angle1, const Vec3f &axis1, value_type angle2, const Vec3f &axis2, value_type angle3, const Vec3f &axis3)
static Matrixf | rotate (value_type angle1, const Vec3d &axis1, value_type angle2, const Vec3d &axis2, value_type angle3, const Vec3d &axis3)
static Matrixf | rotate (const Quat &quat)
static Matrixf | inverse (const Matrixf &matrix)
static Matrixf | orthoNormal (const Matrixf &matrix)
static Matrixf | ortho (double left, double right, double bottom, double top, double zNear, double zFar)
static Matrixf | ortho2D (double left, double right, double bottom, double top)
static Matrixf | frustum (double left, double right, double bottom, double top, double zNear, double zFar)
static Matrixf | perspective (double fovy, double aspectRatio, double zNear, double zFar)
static Matrixf | lookAt (const Vec3f &eye, const Vec3f &center, const Vec3f &up)
static Matrixf | lookAt (const Vec3d &eye, const Vec3d &center, const Vec3d &up)
static Vec3f | transform3x3 (const Vec3f &v, const Matrixf &m)
static Vec3d | transform3x3 (const Vec3d &v, const Matrixf &m)
static Vec3f | transform3x3 (const Matrixf &m, const Vec3f &v)
static Vec3d | transform3x3 (const Matrixf &m, const Vec3d &v)
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount
Protected Attributes inherited from osg::Matrixf
value_type | _mat [4][4]

## Constructor & Destructor Documentation

## RefMatrixf() [1/6]

osg::RefMatrixf::RefMatrixf | ( |  | ) |

inline

References osg::Matrixf::Matrixf(), and osg::Object::Object().

Referenced by clone(), cloneType(), isSameKindAs(), and RefMatrixf().

## RefMatrixf() [2/6]

osg::RefMatrixf::RefMatrixf | ( | const Matrixf & | other | ) |

inline

References osg::Matrixf::Matrixf(), and osg::Object::Object().

## RefMatrixf() [3/6]

osg::RefMatrixf::RefMatrixf | ( | const Matrixd & | other | ) |

inline

References osg::Matrixf::Matrixf(), and osg::Object::Object().

## RefMatrixf() [4/6]

osg::RefMatrixf::RefMatrixf | ( | const RefMatrixf & | other | ) |

inline

References osg::Matrixf::Matrixf(), osg::Object::Object(), and RefMatrixf().

## RefMatrixf() [5/6]

osg::RefMatrixf::RefMatrixf | ( | Matrixf::value_type const *const | def | ) |

inline explicit

References osg::Matrixf::Matrixf(), and osg::Object::Object().

## RefMatrixf() [6/6]

osg::RefMatrixf::RefMatrixf | ( | Matrixf::value_type | a00,
|  | Matrixf::value_type | a01,
|  | Matrixf::value_type | a02,
|  | Matrixf::value_type | a03,
|  | Matrixf::value_type | a10,
|  | Matrixf::value_type | a11,
|  | Matrixf::value_type | a12,
|  | Matrixf::value_type | a13,
|  | Matrixf::value_type | a20,
|  | Matrixf::value_type | a21,
|  | Matrixf::value_type | a22,
|  | Matrixf::value_type | a23,
|  | Matrixf::value_type | a30,
|  | Matrixf::value_type | a31,
|  | Matrixf::value_type | a32,
|  | Matrixf::value_type | a33 )

inline

References osg::Matrixf::Matrixf(), and osg::Object::Object().

## ~RefMatrixf()

virtual osg::RefMatrixf::~RefMatrixf | ( |  | ) |

inline protected virtual

## Member Function Documentation

## className()

virtual const char * osg::RefMatrixf::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

## clone()

virtual Object * osg::RefMatrixf::clone | ( | const CopyOp & |  | ) | const

inline virtual

Clone an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References osg::Object::Object(), and RefMatrixf().

## cloneType()

virtual Object * osg::RefMatrixf::cloneType | ( |  | ) | const

inline virtual

Clone the type of an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References osg::Object::Object(), and RefMatrixf().

## isSameKindAs()

virtual bool osg::RefMatrixf::isSameKindAs | ( | const Object * | obj | ) | const

inline virtual

Reimplemented from osg::Object.

References NULL, osg::Object::Object(), and RefMatrixf().

## libraryName()

virtual const char * osg::RefMatrixf::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

The documentation for this class was generated from the following file:

- Matrixf